/*
	Wabbitcode - An IDE for the Z80 line of TI calculators
	Copyright (C) 2007 Donald Straney

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __FILE_H
#define __FILE_H

#include <gtk/gtk.h>
#include "undo.h"

typedef struct {
	GtkTextBuffer *textbuffer;
	GtkWidget *textview;
	GtkWidget *tablabel;
	GtkWidget *scrolledwin;
	gchar *path;
	action *undo_stack;
	action *undo_stack_end;
	int undo_stack_pos;
	int undo_stack_len;
	GtkTextIter *syntaxhltiter;
} file;

void add_file_chooser_filters (GtkFileChooser*);
void run_syntax_hlt_on_file (file*);
void add_file (gchar*, gint, gchar*);
gboolean remove_file (file*);
gboolean remove_all_files ();
gboolean save_file (file*, gboolean);
gboolean read_file (gchar*, gchar**, guint*);
void open_file (gchar*);

#endif
