/*
	Wabbitcode - An IDE for the Z80 line of TI calculators
	Copyright (C) 2007 Donald Straney

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __MACROS_H
#define __MACROS_H

#include <gtk/gtk.h>

typedef enum {
	MACRO_LEFT,
	MACRO_RIGHT,
	MACRO_UP,
	MACRO_DOWN,
	MACRO_HOME,
	MACRO_END,
	MACRO_DELETE,
	MACRO_BACKSPACE,
	MACRO_INSERT
} macro_action;

//used to represent one step of macro
struct _macro_step {
	macro_action action;
	gchar *text;
	struct _macro_step *next;
};

typedef struct _macro_step macro_step;

void callback_record_macro_toggled_ind (GtkCheckMenuItem*, gpointer);
void callback_record_macro_toggled (GtkToggleToolButton*, gpointer);
void callback_run_macro (GtkWidget*, gpointer);
void callback_show_macro_manager (GtkWidget*, gpointer);
void add_macro_keypress (guint);
void add_macro_insert (const gchar*);

extern gboolean recording_macro;

#endif

