/*
	Wabbitcode - An IDE for the Z80 line of TI calculators
	Copyright (C) 2007 Donald Straney

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __PROJECT_H
#define __PROJECT_H

#include <gtk/gtk.h>

//project filename extension
#define PROJECT_EXTENSION ".wcodeproj"

typedef enum {
	BUILD_NORMAL = 0,
	BUILD_SYMTABLE,
	BUILD_COMMAND
} build_action;

//used to represent one step of build sequence
struct _build_step {
	build_action action;
	gchar *filename;
	gchar *command;
	gint output_type;
	struct _build_step *prev;
	struct _build_step *next;
};

typedef struct _build_step build_step;

extern gboolean project_open;
extern gchar *project_path;
extern build_step *build_sequence;

GtkWidget *init_project_gui ();
void update_project_view (gboolean);
gboolean close_project ();
gboolean is_project_file (gchar*);
void callback_refresh_project_files (GtkWidget*, gpointer);
void callback_close_project (GtkWidget*, gpointer);
void callback_save_project (GtkWidget*, gpointer);
void callback_new_project (GtkWidget*, gpointer);
void callback_show_project_options (GtkWidget*, gpointer);
void open_project (gchar*);

#endif

