#include <stdio.h>
#include <stdlib.h>
//#include <string.h>
#include <strings.h>
#include "list.h"
#include "utils.h"

/*
 * Adds a node to the end of the
 * list, returns the new start
 * of the list
 */

list *list_append (list *first_node, void *data) {
	list *curr_node, *new_node;

	new_node = (list *)malloc_chk (sizeof (list));
	new_node->data = data;
	new_node->next = NULL;

	if (first_node == NULL)
		return new_node;

	curr_node = first_node;
	while (curr_node->next)
		curr_node = curr_node->next;

	curr_node->next = new_node;
	return first_node;
}


/*
 * Adds a node to the beginning
 * of the list, returns the new
 * start of the list
 */

list *list_prepend (list *first_node, void *data) {
	list *new_node;

	new_node = (list *)malloc_chk (sizeof (list));
	new_node->data = data;
	new_node->next = first_node;
	return new_node;
}


/*
 * Inserts a node after prev
 */
list_t *list_insert(list *prev, void *data) {
	list_t *new_next;
	
	new_next = (list_t *) malloc_chk(sizeof(list_t));
	new_next->data = data;
	new_next->next = prev->next;
	
	prev->next = new_next;
	return new_next;
}

/*
 * Removes a node from the list,
 * returns the new start of the
 * list
 */

list *list_remove (list *first_node, list *remove_node) {
	list *curr_node;

	// if the node to remove is the first one, then it's easy
	if (first_node == remove_node)
		return first_node->next;

	// otherwise, find the node before the node to remove
	curr_node = first_node;
	while (curr_node->next != remove_node && curr_node != NULL)
		curr_node = curr_node->next;

		// then move around pointers
	if (curr_node != NULL)	
		curr_node->next = remove_node->next;
	return first_node;
}


/*
 * Frees a list node
 */

void list_free (list *first_node) {
	if (first_node)
		free (first_node);
}

