/*
	Wabbitcode - An IDE for the Z80 line of TI calculators
	Copyright (C) 2007 Donald Straney

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __UNDO_H
#define __UNDO_H

#include <gtk/gtk.h>

typedef enum {
	ACTION_INSERT,
	ACTION_DELETE,
	ACTION_START
} action_type;

struct _action {
	action_type type;
	int offset;
	gchar *text;
	struct _action *next;
	struct _action *prev;
};

typedef struct _action action;

void free_undo_stack (action*);
void add_undo_action (action_type, int, gchar*);
void callback_start_user_action (GtkTextBuffer*, gpointer);
void callback_end_user_action (GtkTextBuffer*, gpointer);
void callback_undo (GtkWidget*, gpointer);
void callback_redo (GtkWidget*, gpointer);

extern gboolean ignore_actions;

#endif
